#!/usr/bin/env bash

if [ $# -ne 2 ]; then
    echo "Please set project name and type."
    exit 1
fi

# export PATH=${HOME}/QtSDK/Desktop/Qt/473/gcc/bin:$PATH
export PATH=/usr/local/Trolltech/Qt-4.7.3-Cocoa/bin:$PATH

name=$1
src=$PWD/$1
build=$PWD/$1-build-desktop
dist=$PWD/dist
apps=$PWD/dist


if [ "$2" == "clean" ];then
    rm -r $build
    exit
fi


export COPYFILE_DISABLE=true

mkdir -p $dist
mkdir -p $dist/src
mkdir -p $apps

echo 'Archiving...'

pushd $1
hg st
hg archive ${dist}/src/${name}.tar.bz2
popd

rm -r $build
mkdir -p $build

echo 'Building...'

pushd $build
qmake $src/$1.pro -spec macx-g++ CONFIG+=release
make -j5

if [ $2 == 'app' ];then

    if [ -r $src/Info_mac.plist ] ; then
	cp $src/Info_mac.plist ${name}.app/Contents/Info.plist
	cp $src/*.icns ${name}.app/Contents/Resources
    fi

    echo 'Deploying...'

    macdeployqt ${name}.app
    rm -r ${name}.app/Contents/Frameworks/QtScript.framework
    rm -r ${name}.app/Contents/Frameworks/QtSvg.framework
    rm -r ${name}.app/Contents/Frameworks/QtDeclarative.framework
    rm -r ${name}.app/Contents/Frameworks/QtNetwork.framework
    rm -r ${name}.app/Contents/Frameworks/QtSql.framework
    rm -r ${name}.app/Contents/Frameworks/QtXmlPatterns.framework

    cp -r ${name}.app ${apps}/

fi

popd



#export PATH=/usr/local/Trolltech/Qt-4.7.1-Carbon/bin:$PATH
#echo $PATH
#
#name=$1
#src=$1
#dist=$PWD/dist
#apps=$PWD/dist
#
#export COPYFILE_DISABLE=true
#
#if [ ! -d $dist ] ; then
#    mkdir $dist
#    mkdir $dist/src
#fi
#
#if [ ! -d $apps ] ; then
#    mkdir $apps
#fi
#
#echo "Copying Source Files..."
#cd $1
#if [ -d ${name}.app ] ; then
#    rm -r ${name}.app    
#fi
#mkdir $src
#cp *.cpp $src
#cp *.h $src
#cp *.xpm $src
#cp *.ui $src
#cp *.ico $src
#cp *.CE3 $src
#cp *.icns $src
#cp *.rc $src
#cp *.cfg $src
#cp $name.pro $src
#rm $src/moc_*.cpp
#rm $src/ui_*.h
#if [ -d nl3c ] ; then
#    cp -r nl3c $src/
#fi
#
#if [ -d bsch3com ] ; then
#    cp -r bsch3com $src/
#fi
#
#echo "Packaging source code.."
#tar -jcf ${dist}/src/${name}.tar.bz2 $src
#rm -r $src
#
#echo "Building..."
#qmake ${name}.pro -spec macx-g++ -r CONFIG+=release
#make clean -j2
#make -j3
#if [ -r Info_mac.plist ] ; then
#    cp Info_mac.plist ${name}.app/Contents/Info.plist
#fi
#cp *.icns ${name}.app/Contents/Resources/
#strip ${name}.app/Contents/MacOS/${name}
#
#cp -r ${name}.app $apps
#macdeployqt ${apps}/${name}.app
##cp -r ../Documents/* $dist
#
##mkdir $dist/LIBV
##cp ../LIBV/* $dist/LIBV
##
##cd $dist
##tar -cvjf ../${name}m.tar.bz2 *
