#!/bin/bash

if [ $# -ne 1 ]; then
    echo "Please set version."
    exit 1
fi

version=$1
dist=$PWD/dist
apps=$PWD/dist
current=$PWD

if [ "$1" == "clean" ];then
    rm -r dist
    ./build.sh BSch3VShared clean
    ./build.sh qtbsch3v clean
    ./build.sh qtlcov clean
#    ./build.sh qtnlist clean
#    ./build.sh qtnut clean
    exit
fi

if [ -d $dist ] ; then
    rm -r $dist
fi
if [ -d $apps ] ; then
    rm -r $apps
fi

./build.sh BSch3VShared lib
./build.sh qtbsch3v app
./build.sh qtlcov app
#./build.sh qtnlist app
#./build.sh qtnut app

pushd buildscripts
hg archive $dist/src/buildscripts.tar.bz2
popd

echo "Copying Documents..."
cp -r Documents/* $dist

#/Developer/Applications/Utilities/PackageMaker.app/Contents/MacOS/PackageMaker -d installer.pmdoc -o dist/Installer.pkg

echo "Compressing..."
cd $dist
tar -cjf $current/bsch3vm-${version}.tar.bz2 *
